"""
    YNAB API Endpoints

    Our API uses a REST based design, leverages the JSON data format, and relies upon HTTPS for transport. We respond with meaningful HTTP response codes and if an error occurs, we include error details in the response body.  API Documentation is at https://api.youneedabudget.com  # noqa: E501

    The version of the OpenAPI document: 2.0.3
    Generated by: https://openapi-generator.tech
"""

import re  # noqa: F401
import sys  # noqa: F401

from ynab_api.model_utils import (  # noqa: F401
    ApiTypeError, ModelComposed, ModelNormal, ModelSimple, cached_property,
    change_keys_js_to_python, convert_js_args_to_python_args, date, datetime,
    file_type, none_type, validate_get_composed_info,
)
from ..model_utils import OpenApiModel
from ynab_api.exceptions import ApiAttributeError


class Account(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
        ('type', ): {
            'None': None,
            'CHECKING': "checking",
            'SAVINGS': "savings",
            'CASH': "cash",
            'CREDITCARD': "creditCard",
            'LINEOFCREDIT': "lineOfCredit",
            'OTHERASSET': "otherAsset",
            'OTHERLIABILITY': "otherLiability",
            'PAYPAL': "payPal",
            'MERCHANTACCOUNT': "merchantAccount",
            'INVESTMENTACCOUNT': "investmentAccount",
            'MORTGAGE': "mortgage",
        },
    }

    validations = {}

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        return (
            bool,
            date,
            datetime,
            dict,
            float,
            int,
            list,
            str,
            none_type,
        )  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        return {
            'id': (
                str,
                none_type,
            ),  # noqa: E501
            'name': (
                str,
                none_type,
            ),  # noqa: E501
            'type': (
                str,
                none_type,
            ),  # noqa: E501
            'on_budget': (bool, ),  # noqa: E501
            'closed': (bool, ),  # noqa: E501
            'balance': (
                int,
                none_type,
            ),  # noqa: E501
            'cleared_balance': (
                int,
                none_type,
            ),  # noqa: E501
            'uncleared_balance': (
                int,
                none_type,
            ),  # noqa: E501
            'transfer_payee_id': (
                str,
                none_type,
            ),  # noqa: E501
            'deleted': (bool, ),  # noqa: E501
            'note': (
                str,
                none_type,
            ),  # noqa: E501
            'direct_import_linked': (bool, ),  # noqa: E501
            'direct_import_in_error': (bool, ),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None

    attribute_map = {
        'id': 'id',  # noqa: E501
        'name': 'name',  # noqa: E501
        'type': 'type',  # noqa: E501
        'on_budget': 'on_budget',  # noqa: E501
        'closed': 'closed',  # noqa: E501
        'balance': 'balance',  # noqa: E501
        'cleared_balance': 'cleared_balance',  # noqa: E501
        'uncleared_balance': 'uncleared_balance',  # noqa: E501
        'transfer_payee_id': 'transfer_payee_id',  # noqa: E501
        'deleted': 'deleted',  # noqa: E501
        'note': 'note',  # noqa: E501
        'direct_import_linked': 'direct_import_linked',  # noqa: E501
        'direct_import_in_error': 'direct_import_in_error',  # noqa: E501
    }

    read_only_vars = {}

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, id, name, type, on_budget, closed, balance,
                           cleared_balance, uncleared_balance,
                           transfer_payee_id, deleted, *args,
                           **kwargs):  # noqa: E501
        """Account - a model defined in OpenAPI

        Args:
            id (str, none_type):
            name (str, none_type):
            type (str, none_type): The type of account. Note: payPal, merchantAccount, investmentAccount, and mortgage types have been deprecated and will be removed in the future.
            on_budget (bool): Whether this account is on budget or not
            closed (bool): Whether this account is closed or not
            balance (int, none_type): The current balance of the account in milliunits format
            cleared_balance (int, none_type): The current cleared balance of the account in milliunits format
            uncleared_balance (int, none_type): The current uncleared balance of the account in milliunits format
            transfer_payee_id (str, none_type): The payee id which should be used when transferring to this account
            deleted (bool): Whether or not the account has been deleted.  Deleted accounts will only be included in delta requests.

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            note (str, none_type): [optional]  # noqa: E501
            direct_import_linked (bool): Whether or not the account is linked to a financial institution for automatic transaction import.. [optional]  # noqa: E501
            direct_import_in_error (bool): If an account linked to a financial institution (direct_import_linked=true) and the linked connection is not in a healthy state, this will be true.. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments."
                % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__, ),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (
            self.__class__, )

        self.id = id
        self.name = name
        self.type = type
        self.on_budget = on_budget
        self.closed = closed
        self.balance = balance
        self.cleared_balance = cleared_balance
        self.uncleared_balance = uncleared_balance
        self.transfer_payee_id = transfer_payee_id
        self.deleted = deleted
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, id, name, type, on_budget, closed, balance,
                 cleared_balance, uncleared_balance, transfer_payee_id,
                 deleted, *args, **kwargs):  # noqa: E501
        """Account - a model defined in OpenAPI

        Args:
            id (str, none_type):
            name (str, none_type):
            type (str, none_type): The type of account. Note: payPal, merchantAccount, investmentAccount, and mortgage types have been deprecated and will be removed in the future.
            on_budget (bool): Whether this account is on budget or not
            closed (bool): Whether this account is closed or not
            balance (int, none_type): The current balance of the account in milliunits format
            cleared_balance (int, none_type): The current cleared balance of the account in milliunits format
            uncleared_balance (int, none_type): The current uncleared balance of the account in milliunits format
            transfer_payee_id (str, none_type): The payee id which should be used when transferring to this account
            deleted (bool): Whether or not the account has been deleted.  Deleted accounts will only be included in delta requests.

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            note (str, none_type): [optional]  # noqa: E501
            direct_import_linked (bool): Whether or not the account is linked to a financial institution for automatic transaction import.. [optional]  # noqa: E501
            direct_import_in_error (bool): If an account linked to a financial institution (direct_import_linked=true) and the linked connection is not in a healthy state, this will be true.. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments."
                % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__, ),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (
            self.__class__, )

        self.id = id
        self.name = name
        self.type = type
        self.on_budget = on_budget
        self.closed = closed
        self.balance = balance
        self.cleared_balance = cleared_balance
        self.uncleared_balance = uncleared_balance
        self.transfer_payee_id = transfer_payee_id
        self.deleted = deleted
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(
                    f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                    f"class with read only attributes.")
